#include <bits/stdc++.h>
using namespace std;

void swapElements(int a, int b);

void solve(int n, vector<int> A, vector<int> C)
{
    vector<bool> used(n, false);
    for(int i = 0; i < n; ++i)
        -- A[i];
    for(int i = 0; i < n; ++i)
        -- C[i];
    vector<vector<int> > M(n);
    for(int i = 0; i < n; ++i)
    {
        if (used[i])
            continue;
        int v = i;
        set<int> colors;
        while (!used[v])
        {
            colors.insert(C[v]);
            used[v] = true;
            v = A[v];
        }
        if (colors.size() == 1 && A[i] != i)
        {
            M[*colors.begin()].push_back(i);
        }
    }
    set<pair<int,int> > S;
    for(int i = 0; i < n; ++i)
    {
        if (M[i].size() > 0)
            S.insert({M[i].size(), i});
    }
    while(S.size() > 1)
    {
        auto p1 = *S.rbegin();
        S.erase(p1);
        auto p2 = *S.rbegin();
        S.erase(p2);
        int a = M[p1.second].back();
        int b = M[p2.second].back();
        M[p1.second].pop_back();
        M[p2.second].pop_back();
        p1.first --;
        p2.first --;
        if (p1.first > 0)
            S.insert(p1);
        if (p2.first > 0)
            S.insert(p2);
        swapElements(a + 1 , b + 1);
        swap(A[a] , A[b]);
        swap(C[a] , C[b]);
    }
    if (S.size() == 1)
    {
        int colour = S.begin()->second;
        int good_elem;
        for(int i = 0; i < n; ++i)
            if (C[i] != colour){
                good_elem = i;
                break;
            }
        for(int i = 0; i < M[colour].size(); ++i)
        {
            int a = good_elem;
            int b = M[colour][i];
            swapElements(a + 1 , b + 1);
            swap(A[a] , A[b]);
            swap(C[a] , C[b]);
            good_elem = b;
        }
    }
    vector<set<pair<int, int> > > CS(n);
    vector<int> prev(n);
    for(int i = 0; i < n; ++i)
        prev[A[i]] = i;
    for(int i = 0; i < n; ++i)
    {
        used[i] = false;
    }
    
    for(int i = 0; i < n; ++i)
    {
        if (used[i]) continue;
        set<int> cols;
        int v = i;
        while (!used[v])
        {
            used[v] = true;
            int good = 0;
            if (C[A[v]] != C[v])
                good = 1;
            CS[C[v]].insert({good, v});
            cols.insert(C[v]);
            v = A[v];
        }
        for(int c: cols)
        {
            while (CS[c].size() > 1)
            {
                auto pa = *CS[c].rbegin();
                int a = pa.second;
                int b = A[a];
                
                CS[C[a]].erase({1, a});
                CS[C[a]].erase({0, a});
                CS[C[b]].erase({1, b});
                CS[C[b]].erase({0, b});
                CS[C[prev[a]]].erase({1, prev[a]});
                CS[C[prev[a]]].erase({0, prev[a]});
                
                swapElements(a + 1 , b + 1);
                swap(A[a] , A[b]);
                swap(C[a] , C[b]);
                
                prev[A[a]] = a;
                prev[b] = b;
                if (a != A[a])
                {
                    if (C[A[a]] != C[a])
                        CS[C[a]].insert({1, a});
                    else
                        CS[C[a]].insert({0, a});
                }
                if (prev[a] != a)
                {
                    if (C[prev[a]] != C[a])
                        CS[C[prev[a]]].insert({1, prev[a]});
                    else
                        CS[C[prev[a]]].insert({0, prev[a]});
                }
                
            }
        }
        for(int c: cols)
        {
            CS[c].clear();
        }
    }
    for(int i = 0; i < n; ++i)
    {
        while (A[i] != i)
        {
            int a = i;
            int b = A[i];
            swapElements(a + 1, b + 1);
            swap(A[a], A[b]);
            swap(C[a], C[b]);
        }
    }
}

int n;
vector<int> books;
vector<int> colours;
vector<pair<int,int> > res;

void error(string s){
    cout << s << endl;
    exit(1);
}

void swapElements(int a, int b)
{
    if (a < 1 || n < a || b < 1 || n < b || a == b){
        error("Wrong pair of books");
    }
    res.push_back(make_pair(a, b));
    --a;--b;
    if (colours[a] == colours[b])
    {
        error("Books have same colour");
    }
    swap(books[a], books[b]);
    swap(colours[a], colours[b]);
}

int main()
{
    freopen("permutation.in", "r", stdin);
    freopen("permutation.out", "w", stdout);
    cin >> n;
    books.resize(n);
    colours.resize(n);
    vector<int> A(n) , C(n);
    for(int i = 0; i < n; ++i)
    {
        cin >> books[i];
        A[i] = books[i];
        -- books[i];
    }
    for(int i = 0; i < n; ++i)
    {
        cin >> colours[i];
        C[i] = colours[i];
        -- colours[i];
    }
    
    solve(n, A, C);
    
    cout << res.size() << endl;
    for(int i = 0; i < res.size(); ++i)
    {
        cout << res[i].first << ' ' << res[i].second << endl;
    }
    
    return 0;
}
